
const DBus = imports.dbus;
const Lang = imports.lang;
const St = imports.gi.St;
const Shell = imports.gi.Shell;
const Gio = imports.gi.Gio;
const Main = imports.ui.main;
const PopupMenu = imports.ui.popupMenu;
const Util = imports.misc.util;
const GLib = imports.gi.GLib;
const GnomeSession = imports.misc.gnomeSession;
const VolumeMenu = imports.ui.status.volume;
// CHANGE THE LINES 'const SEPERATOR, const VOLUME...' etc ONLY, to true or false!!!
//options are true to show and false to not show, you must already have installed the programs for this to run them
//try: sudo apt install pavucontrol paprefs pavumeter pulseaudio-equalizer paman
const POPUP_MENU = true; //adds shortcuts to popup menu on volume/sound menu
const POPUP_MENU_TEXT = "PulseAudio Settings"; //changes the text for the pop-up menu, default is PulseAudio Settings
const SEPERATOR = false;   //Shows a shiny seperator before the shortcuts, doesnt work with popup menu
const CUSTOM_COMMAND = "qpaeq";   //Runs specified command, i.e by default it runs qpaeq which is a front-end for the newer module-equalizer-sink
const CUSTOM = true;   //Shows or hides the custom shortcut above. The text shown can be modified below at 'PA_CUSTOM'.
const VOLUME = true;   //Runs PA Volume Control PA=Pulse Audio
const PREFS = true;   //Runs PA Preferences
const VUMETER = true;   //Runs PA VU Meter
const EQUALIZER = true;   //Runs the PA 'System-Wide' Equalizer.
const MANAGER = true;   //Starts the PA Manager, which can be used to restart pulse audio.
//const MENU_POSITION = "0";   //Shows a shiny seperator before the shortcuts
const PULSEAUDIO_TEXT = ""; //Optionally hide/change/remove the PulseAudio text, hint:add space at end if using text and must be "quoted" always!.
/*These following 5 lines are for locolization, you can change each to that of your own language, this saves the trouble of risky editing below. You can also optionally use these lines instead of the above PULSEAUDIO_TEXT to customize each shortcuts text.*/
const PA_CUSTOM = "Q Equalizer";
const PA_VUCONTROL = "Volume Control";
const PA_PREFERENCES = "Preferences";
const PA_VUMETER = "Volume Meter";
const PA_EQUALIZER = "Equalizer";
const PA_MANAGER = "Manager";
//DONT DO NOT touch anything below this line

let paMenu, paSeperator, paCustom, paVolume, paPrefs, paVumeter, paEqualizer, paManager;

function _onCustomApp() {
    let app = Util.spawn([CUSTOM_COMMAND]);
    app.activate();
}
function init() {
        paMenu = POPUP_MENU;
        paSeperator = SEPERATOR;
        paCustom = CUSTOM;
        paVolume = VOLUME;
        paPrefs = PREFS;
        paVumeter = VUMETER;
        paEqualizer = EQUALIZER;
        paManager = MANAGER;
}
function enable() {
                    if (paMenu == false) {
        pulseMenu = Main.panel._statusArea.volume;
        nItems = pulseMenu.menu.numMenuItems;
                    } else {
        pulseMenu2 = Main.panel._statusArea.volume;
        pulseMenu = new PopupMenu.PopupSubMenuMenuItem(_(POPUP_MENU_TEXT));
        pulseMenu2.menu.addMenuItem(pulseMenu, pulseMenu2.menu.numMenuItems - 1);
        nItems = pulseMenu2.menu.numMenuItems;
                    }
                    if (paSeperator == true) {
        let itemSeparator = new PopupMenu.PopupSeparatorMenuItem();
        pulseMenu.menu.addMenuItem(itemSeparator, nItems - 3);
                    }
                    if (paCustom == true) {
        let paCustom2 = new PopupMenu.PopupMenuItem(_(PULSEAUDIO_TEXT + PA_CUSTOM), 0);
        paCustom2.connect('activate', Lang.bind(paCustom2, _onCustomApp));
        pulseMenu.menu.addMenuItem(paCustom2, nItems - 2);
                    }
                    if (paVolume == true) {
        let paVolume2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + PA_VUCONTROL), 'pavucontrol.desktop', 0);
        pulseMenu.menu.addMenuItem(paVolume2, nItems - 2);
                    }
                    if (paPrefs == true) {
        let paPrefs2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + PA_PREFERENCES), 'paprefs.desktop', 0);
        pulseMenu.menu.addMenuItem(paPrefs2, nItems - 2);
                    }
                    if (paVumeter == true) {
        let paVumeter2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + PA_VUMETER), 'pavumeter.desktop', 0);
        pulseMenu.menu.addMenuItem(paVumeter2, nItems - 2);
                    }
                    if (paEqualizer == true) {
        let paEqualizer2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + PA_EQUALIZER), 'pulseaudio-equalizer.desktop', 0);
        pulseMenu.menu.addMenuItem(paEqualizer2, nItems - 2);
                    }
                    if (paManager == true) {
        let paManager2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + PA_MANAGER), 'paman.desktop', 0);
        pulseMenu.menu.addMenuItem(paManager2, nItems - 2);
                    }
}
function disable() {
                    if (paSeperator == true) {
        itemSeparator.destroy();
                    }
                    if (paCustom == true) {
        paCustom2.destroy();
                    }
                    if (paVolume == true) {
        paVolume2.destroy();
                    }
                    if (paPrefs == true) {
        paPrefs2.destroy();
                    }
                    if (paVumeter == true) {
        paVumeter2.destroy();
                    }
                    if (paEqualizer == true) {
        paEqualizer2.destroy();
                    }
                    if (paManager == true) {
        paManager2.destroy();
                    }
}
